keranjang/urls.py
from django.urls import path
from .views import keranjang_view, keranjang_add_view, keranjang_update_jumlah_view, keranjang_hapus_view

app_name = 'keranjang'

urlpatterns = [
    path('', keranjang_view, name='keranjang'),
    path('add', keranjang_add_view, name='add'),
    path('update-jumlah', keranjang_update_jumlah_view, name='update-jumlah'),
    path('hapus', keranjang_hapus_view, name='hapus')
]

kupon/urls.py
from django.urls import path
from .views import semua_kupon_view, kupon_api_view

app_name = 'kupon'

urlpatterns = [
    path('', semua_kupon_view, name='semua-kupon'),
    path('api/semua', kupon_api_view, name='kupon-api')
]

onlineshop/urls.py
from django.contrib import admin
from django.urls import path, include
from register import views as regviews

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('barang/', include('barang.urls')),
    path('kategori/', include('kategori.urls')),
    path('kupon/', include('kupon.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('shopadmin/', include('shopadmin.urls')),
    path('', include('landing.urls')),
    path('register/', include('register.urls', namespace='register')),
    path('keranjang/', include('keranjang.urls')),
    path('', include('django.contrib.auth.urls')),
    path('', include('social_django.urls', namespace='social')),
    # path('login/', regviews.login, name='login'),
]

transaksi/urls.py
from django.urls import path
from .views import all_transaction_view, cepat_view, beli_cepat_view, riwayat_cepat_view

app_name = 'transaksi'

urlpatterns = [
    path('', all_transaction_view, name='all-transactions'),
    path('cepat/', cepat_view, name='transaksi-cepat'),
    path('riwayat-cepat', riwayat_cepat_view, name='riwayat-cepat'),
    path('api/beli-cepat', beli_cepat_view, name='beli-cepat')
]

keranjang/models.py
from django.db import models

# Create your models here.

keranjang/views.py
import json
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.forms.models import model_to_dict
from django.http import JsonResponse

from tk2.models import KeranjangBarang, KeranjangBarangEntry
from barang.models import Barang


@login_required
def keranjang_view(request):
    try:
        keranjang_user = KeranjangBarang.objects.get(
            user=request.user, active=True)
    except:
        keranjang_user = None

    context = {
        "keranjang": keranjang_user
    }

    return render(request, "keranjang/keranjang.html", context)


@login_required
def keranjang_add_view(request):
    if request.method == "POST":
        try:
            keranjang_user, _ = KeranjangBarang.objects.get_or_create(
                user=request.user, active=True)

            data = json.loads(request.body)
            barang_user = Barang.objects.get(pk=data.get("barang_id"))

            if not KeranjangBarangEntry.objects.filter(barang=barang_user, keranjang=keranjang_user).exists():
                entry = KeranjangBarangEntry(
                    barang=barang_user, jumlah=1, keranjang=keranjang_user)
                entry.save()
            else:
                raise Exception("Barang sudah ada di keranjang!")

            return JsonResponse({'success': True, 'entry': model_to_dict(entry)})
        except Exception as e:
            return JsonResponse({'success': False, 'error': str(e)})


@login_required
def keranjang_update_jumlah_view(request):
    if request.method == "POST":
        try:
            keranjang_user, _ = KeranjangBarang.objects.get_or_create(
                user=request.user, active=True)

            data = json.loads(request.body)

            barang_user = KeranjangBarangEntry.objects.get(pk=data.get("id"))
            if int(data.get("jumlah")) <= barang_user.barang.stok:
                barang_user.jumlah = int(data.get("jumlah"))
                barang_user.save()
            else:
                raise Exception("Jumlah lebih besar dari stok!")
            return JsonResponse({'success': True, 'entry': model_to_dict(barang_user)})
        except Exception as e:
            return JsonResponse({'success': False, 'error': str(e)})


@login_required
def keranjang_hapus_view(request):
    if request.method == "POST":
        try:
            keranjang_user, _ = KeranjangBarang.objects.get_or_create(
                user=request.user, active=True)

            data = json.loads(request.body)

            barang_user = KeranjangBarangEntry.objects.get(pk=data.get("id"))
            barang_user.delete()

            return JsonResponse({'success': True, 'keranjang': model_to_dict(keranjang_user)})
        except Exception as e:
            return JsonResponse({'success': False, 'error': str(e)})

keranjang/templates/keranjang/keranjang.html
{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
<div class="container">
  <h2 class="">
    Keranjang Belanja
  </h2>
  <div class="row mt-3">
    {% if keranjang %}
        <table class="table table-striped">
        <thead>
            <tr>
            <th scope="col">Barang</th>
            <th scope="col">Qty</th>
            <th scope="col">Harga</th>
            <th scope="col">Actions</th>
            </tr>
        </thead>
        <tbody>
        {% for barang in keranjang.entry.all %}
        <tr>
        <td>{{barang.barang.nama}}</td>
        <td>
            <form class="jumlah-form">
                <input type="hidden" name="id" value="{{barang.id}}">
            <input type="number" name="jumlah" value="{{barang.jumlah}}" min=1 max={{barang.barang.stok}}>
            <button type="submit" class="btn btn-success btn-update">Update</button>
            </form>
        </td>
        <td>Rp. {{barang.harga_total|intcomma}}</td>
        <td><button class="btn btn-danger btn-hapus" data-barang-id="{{barang.id}}">Hapus</button></td>
        </tr>
        {% endfor %}
        </tbody>
        </table>
        <a href="{% url 'transaksi:transaksi-cepat' %}" class="btn btn-info">Checkout | Transaksi Cepat</a>
    {% else %}
    Anda tidak memiliki keranjang belanja!
    {% endif %}
  </div>
</div>

{% load static %} {% endblock %} {% block head %}
<title>Keranjang | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://unpkg.com/swiper/css/swiper.min.css" />

{% endblock %}
{% block js %}
<script>
    $(function() {
        $(".jumlah-form").submit(async function(e) {
            e.preventDefault();
            const jumlah = e.target.jumlah.value
            const id = e.target.id.value

            const data = {
                id,
                jumlah
            }

            const csrftoken = Cookies.get('csrftoken');
            const response = await fetch(`{% url 'keranjang:update-jumlah' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            const notyf = new Notyf();
            if (result.success) {
                notyf.success(`Kuantitas sukses diupdate!`);
                e.target.id.value = result.entry.jumlah;
                e.target.jumlah.readOnly = true;
            } else {
                notyf.error(`Kuantitas gagal diupdate!`);
                notyf.error(result.error);
            }
        });

        $(".btn-hapus").click(async function() {
            const id = this.dataset.barangId;

            const data = {
                id
            }

            const csrftoken = Cookies.get('csrftoken');
            const response = await fetch(`{% url 'keranjang:hapus' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            const notyf = new Notyf();
            if (result.success) {
                notyf.success(`Barang berhasil dihapus!`);
                $(this).parents("tr").remove();
            } else {
                notyf.error(`Barang gagal dihapus!`);
                notyf.error(result.error);
            }
        });
    });
</script>
{% endblock%}